﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Drawing
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //Ваша функция
        private bool function(double x, double y)
        {
            double z1 = Math.Abs(x) + Math.Abs(y);
            double z2 = x * x + y * y;
            return (z1 > 5) & (z1 < 10) ^ (z2 > 25) & (z2 < 100); 
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //выбираем область в пикселях
            int w = pictureBox1.Width, h = pictureBox1.Height;  //Узнаём ширину и высоту в пикселях
            int nw = w / 2;
            int nh = h / 2;
            if (nw > nh) nw = nh;       //делаем её квадратной     
            int k = nw / 10;            //количество пикселей в 1.0
            if (k < 1) k = 1;
            int n = nw;
            double dx = 1.0 / k;
            double dy = dx;

            Graphics g = pictureBox1.CreateGraphics();          //Начинаем работу с pictureBox1
            g.Clear(Color.White);                               //Очищаем наш рисунок
            Pen myBlackPen = new Pen(Color.Black, 1);           //Создаём чёрную ручку шириной 1 пиксель   
            Pen myRedPen = new Pen(Color.Red, 3);               //Создаём красную ручку шириной 2 пикселя   
            



            SolidBrush myBlackBrash = new SolidBrush(Color.Black);
            for (int i = -n; i <= n; i++)
            {
                for (int j = -n; j <= n; j++)
                {
                    if (function(i * dx, j * dy))
                    {
                        g.DrawRectangle(myBlackPen, i + n, j + n, 1, 1);
                    }
                }
            }
            g.DrawLine(myRedPen, n, 0, n, n * 2);
            g.DrawLine(myRedPen, 0, n, n * 2, n);
            myRedPen.Width = 1;
            myRedPen.DashStyle = DashStyle.Dash;                //Теперь ручка пунктирная
            int li;
            for (int i = 0; i < 20; ++i)
            {
                li = 2 * n / 20 * i + 2;
                g.DrawLine(myRedPen, li, 0, li, n * 2);
                g.DrawLine(myRedPen, 0, li, n * 2, li);
            }
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            Graphics g = pictureBox1.CreateGraphics();
            g.Clear(Color.White);
        }
    }
}
